package status;

use Time::HiRes qw(time);

$before_mesg = '';
$after_mesg = '';
$init_time = 0;
$total_steps = 0;
$| = 1;

sub init {
  ($total_steps, $before_mesg) = @_;
  print "$before_mesg\n";
  $init_time = time;
  #system "clear";
}


sub progress {
   my ($current_step) = @_;
   if ($current_step == 0) { #nothing happened
     return;
   }
   my $elapsed_time = time - $init_time;
   my $elapsed_min = int($elapsed_time / 60);
   my $elapsed_sec = int($elapsed_time) % 60;

   my $remain_time = (($elapsed_time / $current_step) * ($total_steps - $current_step)) + 1;
   my $remain_min = int($remain_time / 60);
   my $remain_sec = int($remain_time) % 60;

   my $pct = ($current_step / $total_steps) * 100;
   for (1..72) {print " ";}  #blank out
   print "\r"; #overprint
   my $bars = int($pct / 2);
   for (1..$bars) { print "|"; }
   for ($bars..49) { print " "; }
   printf " (%4.1f%%) ", $pct;
   print " Left: ";
   print $remain_min."m " if ($remain_min > 0);
   print $remain_sec."s";
   print "\r"; #overprint
   #if ($after_mesg) { print "\n$after_mesg\n"; }
}

sub showmesg {
  $after_mesg .= join('', @_)."\n";
}
return 1;
