#! /usr/bin/perl -w
#
package util;
# Utility routine collection
use setup;  #for machine dependencies
use Cwd;
sub MScwd {
# returns complete path name for current directory, with the
#  final part guaranteed to be a long name
$knownMSW = setup::isitMSW;
$dir = getcwd(); # default if the MSW test comes up undefined; complete path
  if ($knownMSW) { #not easy to get a proper long name for a MSW current directory!
    $dir = `dir /x ..`; #command should return both names for each file in parent
    $cd = `cd`; #returns path of current directory, but may be long or short name
    @dirf = split(' ',$dir);
    @cdf = split(/\\/,$cd); #path sep is "\"
    chomp($me = $cdf[scalar(@cdf)-1]); #take just final name 
    $worked = 0;
    L: for ($D=0; defined($dirf[$D]); $D++) { # over all data in parent
      if ($dirf[$D] =~ $me) { #found whichever kind of name
        $worked = 1;
        last L;
      }
    }
    die "Windows kludge to get current directory name failed." unless ($worked);
    if ($dirf[$D] =~ /~/) { #it was a short name
      $D++;  #next is long name in the dir /x line
    }
    $cdf[scalar(@cdf)-1] = $dirf[$D];
    $dir = join('\\',@cdf);
  }
#print "CWD path is: $dir\n";  #debug
return $dir;
}

sub GNUplotit {
# parameter:  file name containing call-dependent stuff
#  --careful, may be "complot"...
# this routine adds some before and some after to centralize
# what may change often, puts result in file "complot"

my($partfile) = shift;
my($ttype,$line);
$ttype = setup::GNUterm();
open(CP, ">.tmp") || die "Can't create plot file .tmp for GNUPlot commands";

if ($ttype ne "none") {
#stuff before
print CP <<"BEFORE";
set terminal $ttype
BEFORE
}

if (defined($partfile && -e $partfile)) { #copy the middle, if any
  open(MID,"<$partfile");
  while ($line = <MID>) {
    print CP $line;
  }
  close(MID);
}

#stuff after
print CP <<"AFTER";
pause -1
AFTER

close(CP);
rename ".tmp","complot";
system("gnuplot complot");
return;
}
return 1;
